/* *************************************************************************** */
/*!
		\file
		\brief MpȈՃc[Lbg
		\author 
		\date 2003.Jun.29
		\version 2.0
		
		xNg̉ZAxNgƃXJ[Ԃ̉ZAtB^[AM
		ȂǂsCuB
*/
/* *************************************************************************** */
#ifndef INCL_SIGNALTOOLKIT
#define INCL_SIGNALTOOLKIT

/*-----------------------------------------------------------------------------	
/		O stk
/----------------------------------------------------------------------------*/
/*!
		\namespace stk
		\brief VOic[LbgO
		
		stk̓VOic[LbgNXp̖OԂłBVOic[Lbg
		鎯ʎqׂ͂Ă̒Ő錾܂B
*/
namespace stk{		// signal tool kit
/*-----------------------------------------------------------------------------	
/		NX CFilter
/--------------------------------------------------------------------------*/
/*! 
		\brief tB^[p̒ۃNX
		
		CFilter̓tB^[p֐̒ۃNXB̃NX͎q
		߂̃C^[tF[XpӂB
		ΏۂƂȂtB^[͓1nAo1nBf[^͔zƂ
		^̂ŁAftB^[ȂǂɊg邱ƂeՂɂłB
		o͂̓ubNĂB܂A1Tvɏ\bh
		runĂԂ̂ł͂ȂACӂcount̃f[^܂Ƃ߂ďB
		ɂă\bhĂяoɕKvȒȃp[^Xgɂ
		I[o[wbh𑊑ΓIɌyłB
*/
	class CFilter{
	protected:
		short * h;				/*!< CpXB
									CpX^z̓RXgN^
									ĂяoɃp[^[Ƃė^B
									CFilter͂̔zւ̃|C^hɊi[B
								*/
		short * delayline;		/*!< xiԕϐjB
									xp̔z̓RXgN^̌ĂяoɓI
									mۂB̂߁Aϐ̓|C^ƂĐ錾B
								*/
		short * curptr;			/*!< ݂̒x̃|C^B
									̃|C^ delayline ̂ƂV
									f[^wBRXgN^ɂdelayline
									lɏ܂B
								*/
		int taps;				/*!< ^bvB̕ϐ̓RXgN^Ăяoɂ
									܂B
								*/
	public:
								/*! 
									\brief tB^pRXgN^
									tB^[ł͂ȂP֐ƂĎgꍇ͂g܂B
									ϐ͊mۂ܂B
									*/
		CFilter();				
		
			 					/*! 
									\brief tB^ϐRXgN^
									CFilter̃RXgN^͗^ꂽtaps̑傫
									zq[vɊmۂAdelaylineɑB
									܂AcurptrdelaylineƓɂBhɂcoeffInit
									B
										\param ataps ^bvw肷B
										\param coeffInit CpX̏l^܂B
			
								*/
		CFilter( int aTaps, short *coeffInit );
								/*!
									 fXgN^BdelaylineJB
								*/
		virtual ~CFilter();		
								/*!
									\brief tB^[s֐B
									\param dst 		o̓f[^ւ̃|C^B̃|C^
													̓f[^̍ŏ̃f[^wB
									\param src		̓f[^ւ̃|C^B̃|C^
													ŏ̏o̓f[^ꏊwB
									\param count	̓f[^B܂Ƃ߂ĉ̃f[^
													邩w肷BȂׂ傫
													l^قI[o[wbhł܂B
								*/

		virtual void run( short dst[], short src[],	unsigned int count	)=0;
	};	
/*-----------------------------------------------------------------------------	
/		NX CFIRFilter
/----------------------------------------------------------------------------*/
/*!
		\brief FIRtB^NX
		
		CFirFilterFirtB^[pNXB
*/
	class CFirFilter : public CFilter{
	public:
				/*!
					\brief RXgN^B
					\param ataps ^bvw肷B
					\param coeffInit CpX^܂B
					
					ɉ܂B
				*/
		CFirFilter( int aTaps, short * coeffInit )
				: CFilter( aTaps, coeffInit ){};
				/*! 
					\brief tB^[s֐B
					
					FIRtB^[ASYsBRXgN^ɗ^
					CpXɂFIRsrcf[^Ɏ{AdstzɊi[B
					^bvRXgN^ɗ^p[^Ō܂܂B
					
					\param dst		o̓f[^ւ̃|C^B̃|C^
									̓f[^̍ŏ̃f[^wB
					\param src		̓f[^ւ̃|C^B̃|C^
									ŏ̏o̓f[^ꏊwB
					\param count 	̓f[^B
									܂Ƃ߂ĉ̃f[^邩w肷BȂׂ傫
									l^قI[o[wbhł܂B
				*/
		virtual void run( 		
			short dst[],
			short src[],
			unsigned int count
		);
	};
	
/*-----------------------------------------------------------------------------	
/		NX CUpSampler
/----------------------------------------------------------------------------*/
/*! 
		\brief C^[|[^[NX
		
		CUpSmpler̓C^[|[VpNXBAbvTv
		RXgN^ŗ^܂B
*/
	class CUpSampler : public CFilter{
	private:
				/*!
					AbvTvB
				*/
		int ratio;
				/*!
					ŗpϐB
				*/
		int tapsDivRatio;
	public:
				/*!
					\brief RXgN^B
					\param ataps ^bvw肷BaRatio̐{łȂ΂Ȃ܂B
					\param coeffInit CpX^܂B
					\param aRatio AbvTv
					
					AbvTṽC^[|[VtB^B
					tB^̏̂قAAbvTv ratio B
				*/	
		CUpSampler(	int taps, short * coeffInit, int aRatio	);
				/*!
					\brief AbvTvs\bhB
					\param dst		o̓f[^ւ̃|C^B̃|C^
									̓f[^̍ŏ̃f[^wB
					\param src		̓f[^ւ̃|C^B̃|C^
									ŏ̏o̓f[^ꏊwB
					\param count 	̓f[^B
									܂Ƃ߂ĉ̃f[^邩w肷BȂׂ傫
									l^قI[o[wbhł܂B

					AbvTvɃC^[|[VtB^sB
				*/
		virtual void run( short dst[], short src[],	unsigned int count );

	};
/*-----------------------------------------------------------------------------	
/		NX CDownSampler
/----------------------------------------------------------------------------*/
/*! 
		\brief fV[^[NX
		
		CDownSmpler̓fV[VpNXBfV[V̓RXgN^
		w肷B
*/
	class CDownSampler : public CFilter{
	private:
				/*!
					_ETvB
				*/		
		int ratio;
	public:
				/*!
					\brief RXgN^B
					\param ataps ^bvw肷B
					\param coeffInit CpX^܂B
					\param aRatio _ETv
					
					_ETṽfV[VtB^B
					tB^̏̂قA_ETv ratio B
				*/		
		CDownSampler(
			int taps,
			short * coeffInit, 
			int aRatio
			);
				/*!
					\brief _ETvs\bhB
					\param dst		o̓f[^ւ̃|C^B̃|C^
									̓f[^̍ŏ̃f[^wB
					\param src		̓f[^ւ̃|C^B̃|C^
									ŏ̏o̓f[^ꏊwB
					\param count 	̓f[^Bratio̐{łȂ΂Ȃ܂B
									܂Ƃ߂ĉ̃f[^邩w肷BȂׂ傫
									l^قI[o[wbhł܂B

					fV[VtB^sɃ_ETvs܂B
				*/
		virtual void run( short dst[], short src[],	unsigned int count	);
			
	};	

/*-----------------------------------------------------------------------------	
/		NX COscillator
/----------------------------------------------------------------------------*/
/*! 
		\brief MNX
		
		MiUj̊ƂȂ钊ی^BM̓RXgN^
		w肵gŐUM^ꂽxNgɊi[B
*/
	class COscillator {
	protected:
							//! ϐ
		int phase[4];		// phase͓ʑ(L,H)Ǝg(L,H)4[hȂ
							// ꂼ32bitŁAʑ̏16rbg\Ɏg
							// Ԃ͉ʂPL,PH,FL,FH
							// ʑ͕ȂŁA32bit2΂킷
							// g1TvƂ̈ʑip킷B
	public:
							// freq = ( 2^32 / Tvg ) * ړI̎g
				/*!
					\brief RXgN^
					\param freqH	g̏16rbgB
					\param freqL	g̉16rbgB

					RXgN^32rbgł킷g󂯎ĔU
					Bʑ0ɂȂBg͎̎ŕ\镄Ȃ
					
					freq = ( 2^32 / Tvg ) * ړI̎g
				*/
		COscillator( unsigned int freqH, unsigned int freqL );
				/*!
					\brief fXgN^
					
					fXgN^͉ȂBq̃NX̂߂ɉz\bh
					ƂẴC^[tF[X񋟂
				*/
		virtual ~COscillator(){};
				/*!
					\brief gݒ
					\param freqH g̏16rbg
					\param freqL g̉16rbg
					
					setFreq͎gݒ肷B32rbg̎gfreq

					freq = ( 2^32 / Tvg ) * ړI̎g
					
					ł킳B㉺16rbgɕė^
				*/
		virtual void setFreq( unsigned int freqH, unsigned int freqL );		// ʑ̋ύX
				/*!
					\brief ʑݒ
					\param phaseH g̏16rbg
					\param phaseL g̉16rbg
					
					setPhase͎gݒ肷B32rbg̈ʑ phase

					phase = ( 2^32 / 2 ) * ړÏʑ(WA)
					
					ł킳B㉺16rbgɕė^
				*/
		virtual void setPhase( unsigned int phaseH, unsigned int phaseL );	// g̋ύX
				/*!
					\brief gύX
					\param freqHDelta gύXʂ̏16rbg
					\param freqLDelta gύXʂ̉16rbg
					
					addFreq͎gݒ肷B32rbg̎gύXdelta

					delta = ( 2^32 / Tvg ) * ύXg
					
					ł킳B㉺16rbgɕė^B
					p[^[͕ȂA2̕␔ŕ̐^
					Ύg邱ƂłB
				*/
		virtual void addFreq( unsigned int freqHDelta, unsigned int freqLDelta );
				/*!
					\brief ʑύX
					\param phaseHDelta ʑύXʂ̏16rbg
					\param phaseLDelta ʑύXʂ̉16rbg
					
					addPhase͈ʑݒ肷B32rbg̈ʑύXdeltaP

					deltaP = ( 2^32 / 2 ) * ʑʑύX(WA)
					
					ł킳B㉺16rbgɕė^B
					p[^[͕ȂA2̕␔ŕ̐^
					Έʑ߂ƂłB
				*/
		virtual void addPhase( unsigned int phaseHDelta, unsigned int freqLDelta );
				/*!
					\brief M
					\param i ʑ( in phase )̐Mo͂obt@
					\param count Tv
					
					Mz i ɏo͂BTv count Ŏw肷B
				*/
		virtual void run ( short i[], unsigned int count)=0;
				/*!
					\brief M
					\param i ʑ( in phase )̐Mo͂obt@
					\param q ʑ/2i( quadrature phase )Mo͂obt@
					\param count Tv
					
					Mz i,q  ɏo͂BTv count Ŏw肷B
				*/
		virtual void run ( short i[], short q[], unsigned int count )=0;
	};

/*-----------------------------------------------------------------------------	
/		NX CSinCosDDS
/----------------------------------------------------------------------------*/
/*! 
		\brief gNX
		
		gƗ]g𐶐NXB
*/
			// Op֐̉@ɂDDS
	class CSinCosDDS: public COscillator{
	public:
				/*!
					\brief RXgN^
					\param freqH	g̏16rbgB
					\param freqL	g̉16rbgB

					RXgN^32rbgł킷g󂯎ĔU
					Bʑ0ɂȂBg͎̎ŕ\镄Ȃ
					
					freq = ( 2^32 / Tvg ) * ړI̎g
				*/
		CSinCosDDS( int freqH, int freqL ) : COscillator( freqH, freqL ){};
				/*!
					\brief g
					\param i go͂obt@
					\param count Tv
					
					gz i ɏo͂BTv count Ŏw肷B
				*/
		virtual void run ( short i[], unsigned int count );
				/*!
					\brief M
					\param i go͂obt@
					\param q ]go͂obt@
					\param count Tv
					
					gƗ]gz i,q  ɏo͂BTv count Ŏw肷B
				*/
		virtual void run ( short i[], short q[], unsigned int count );
	};

// *************************************** ֐ ***************************************
			/*!
				\brief Rs[֐B
				\param dst 		o̓f[^ւ̃|C^B̃|C^
								̓f[^̍ŏ̃f[^wB
				\param src		̓f[^ւ̃|C^B̃|C^
								ŏ̏o̓f[^ꏊwB
				\param count	̓f[^B܂Ƃ߂ĉ̃f[^
								邩w肷BȂׂ傫
								l^قI[o[wbhłB
				\param dstStep	o̓f[^̊Ԋu^BAȂ1
				\param srcStep	̓f[^̊Ԋu^BAȂ1
			*/
#pragma linkage_name _stkCopyFunc
		extern void copy( short dst[], short src[], unsigned int count, unsigned int dstStep=1, unsigned int srcStep=1 );
			/*!
				\brief MAX֐Bvfmrđ傫ȂقI
				\param dst 		o̓f[^ւ̃|C^B̃|C^
								̓f[^̍ŏ̃f[^wB
				\param src1		̓f[^ւ̃|C^B̃|C^
								ŏ̏o̓f[^ꏊwB
				\param src2		̓f[^ւ̃|C^B̃|C^
								ŏ̏o̓f[^ꏊwB
				\param count	̓f[^B܂Ƃ߂ĉ̃f[^
								邩w肷BȂׂ傫
								l^قI[o[wbhłB
								
				̗vfrđ傫ȗvfo
			*/
#pragma linkage_name _stkMaxFunc
	extern void max( short dst[], short src1[], short src2[], unsigned int count );
			/*!
				\brief MAX֐BxNgƃXJ[̔r
				\param dst 		o̓f[^ւ̃|C^B̃|C^
								̓f[^̍ŏ̃f[^wB
				\param src1		̓f[^ւ̃|C^B̃|C^
								ŏ̏o̓f[^ꏊwB
				\param src2		̓f[^2BXJ[^
				\param count	̓f[^B܂Ƃ߂ĉ̃f[^
								邩w肷BȂׂ傫
								l^قI[o[wbhłB
								
				̗vfrđ傫ȗvfo
			*/
#pragma linkage_name _stkMaxFunc2
	extern void max( short dst[], short src1[], short src2, unsigned int count );
			/*!
				\brief MAX֐BxNgƃXJ[̔r
				\param dst 		o̓f[^ւ̃|C^B̃|C^
								̓f[^̍ŏ̃f[^wB
				\param src1		̓f[^2BXJ[^
				\param src2		̓f[^ւ̃|C^B̃|C^
								ŏ̏o̓f[^ꏊwB
				\param count	̓f[^B܂Ƃ߂ĉ̃f[^
								邩w肷BȂׂ傫
								l^قI[o[wbhłB
								
				̗vfrđ傫ȗvfo
			*/
	inline void max( short dst[], short src1, short src2[], unsigned int count )
	{
		max( dst, src2, src1, count );
	}
//--------------------------------------------------------------------------	

			/*!
				\brief MIN֐Bvfmrďق
				\param dst 		o̓f[^ւ̃|C^B̃|C^
								̓f[^̍ŏ̃f[^wB
				\param src1		̓f[^ւ̃|C^B̃|C^
								ŏ̏o̓f[^ꏊwB
				\param src2		̓f[^ւ̃|C^B̃|C^
								ŏ̏o̓f[^ꏊwB
				\param count	̓f[^B܂Ƃ߂ĉ̃f[^
								邩w肷BȂׂ傫
								l^قI[o[wbhłB
								
				̗vfrďȗvfo
			*/
			
#pragma linkage_name _stkMinFunc
	extern void min( short dst[], short src1[], short src2[], unsigned int count );
			/*!
				\brief MIN֐BxNgƃXJ[̉Z
				\param dst 		o̓f[^ւ̃|C^B̃|C^
								̓f[^̍ŏ̃f[^wB
				\param src1		̓f[^ւ̃|C^B̃|C^
								ŏ̏o̓f[^ꏊwB
				\param src2		̓f[^
				\param count	̓f[^B܂Ƃ߂ĉ̃f[^
								邩w肷BȂׂ傫
								l^قI[o[wbhłB
								
				̗vfrďȗvfo
			*/
			
#pragma linkage_name _stkMinFunc2
	extern void min( short dst[], short src1[], short src2, unsigned int count );

			/*!
				\brief MIN֐BxNgƃXJ[̉Z
				\param dst 		o̓f[^ւ̃|C^B̃|C^
								̓f[^̍ŏ̃f[^wB
				\param src1		̓f[^ւ̃|C^B̃|C^
								ŏ̏o̓f[^ꏊwB
				\param src2		̓f[^
				\param count	̓f[^B܂Ƃ߂ĉ̃f[^
								邩w肷BȂׂ傫
								l^قI[o[wbhłB
								
				̗vfrďȗvfo
			*/
			

	inline void min( short dst[], short src1, short src2[], unsigned int count )
	{
		min( dst, src2, src1, count );
	}


//--------------------------------------------------------------------------	
			
			/*!
				\brief ϊ֐Bvfm̕
				\param dst 		o̓f[^ւ̃|C^B̃|C^
								̓f[^̍ŏ̃f[^wB
				\param src1		̓f[^ւ̃|C^B̃|C^
								ŏ̏o̓f[^ꏊwB
				\param src2		̓f[^ւ̃|C^B̃|C^
								ŏ̏o̓f[^ꏊwB
				\param count	̓f[^B܂Ƃ߂ĉ̃f[^
								邩w肷BȂׂ傫
								l^قI[o[wbhłB
			*/
#pragma linkage_name _stkAverageFunc
		extern void ave( short dst[], short src1[], short src2[], unsigned int count );
			/*!
				\brief ϊ֐BxNgƃXJ[
				\param dst 		o̓f[^ւ̃|C^B̃|C^
								̓f[^̍ŏ̃f[^wB
				\param src1		̓f[^ւ̃|C^B̃|C^
								ŏ̏o̓f[^ꏊwB
				\param src2		̓f[^
				\param count	̓f[^B܂Ƃ߂ĉ̃f[^
								邩w肷BȂׂ傫
								l^قI[o[wbhłB
			*/

#pragma linkage_name _stkAverageFunc2
		extern void ave( short dst[], short src1[], short src2, unsigned int count );
			/*!
				\brief ϊ֐BxNgƃXJ[
				\param dst 		o̓f[^ւ̃|C^B̃|C^
								̓f[^̍ŏ̃f[^wB
				\param src1		̓f[^
				\param src2		̓f[^ւ̃|C^B̃|C^
								ŏ̏o̓f[^ꏊwB
				\param count	̓f[^B܂Ƃ߂ĉ̃f[^
								邩w肷BȂׂ傫
								l^قI[o[wbhłB
			*/
		inline void ave( short dst[], short src1, short src2[], unsigned int count )
		{
			ave( dst, src2, src1, count );
		}
//--------------------------------------------------------------------------		

/*!
				\brief Z֐Bvfů|Z
				\param dst 		o̓f[^ւ̃|C^B̃|C^
								̓f[^̍ŏ̃f[^wB
				\param src1		̓f[^ւ̃|C^B̃|C^
								ŏ̏o̓f[^ꏊwB
				\param src2		̓f[^ւ̃|C^B̃|C^
								ŏ̏o̓f[^ꏊwB
				\param count	̓f[^B܂Ƃ߂ĉ̃f[^
								邩w肷BȂׂ傫
								l^قI[o[wbhłB
			*/
#pragma linkage_name _stkMultiplyFunc
		extern void mul( short dst[], short src[], short src2[], unsigned int count );
			/*!
				\brief Z֐BxNgƃXJ[
				\param dst 		o̓f[^ւ̃|C^B̃|C^
								̓f[^̍ŏ̃f[^wB
				\param src1		̓f[^ւ̃|C^B̃|C^
								ŏ̏o̓f[^ꏊwB
				\param src2		̓f[^
				\param count	̓f[^B܂Ƃ߂ĉ̃f[^
								邩w肷BȂׂ傫
								l^قI[o[wbhłB
			*/
#pragma linkage_name _stkMultiplyFunc2
		extern void mul( short dst[], short src1[], short src2, unsigned int count );
			/*!
				\brief Z֐BxNgƃXJ[
				\param dst 		o̓f[^ւ̃|C^B̃|C^
								̓f[^̍ŏ̃f[^wB
				\param src1		̓f[^
				\param src2		̓f[^ւ̃|C^B̃|C^
								ŏ̏o̓f[^ꏊwB
				\param count	̓f[^B܂Ƃ߂ĉ̃f[^
								邩w肷BȂׂ傫
								l^قI[o[wbhłB
			*/

		inline void mul( short dst[], short src1, short src2[], unsigned int count )
		{
			mul( dst, src2, src1, count );
		}		
//--------------------------------------------------------------------------	
			/*!
				\brief Z֐BvfȗZ
				\param dst 		o̓f[^ւ̃|C^B̃|C^
								̓f[^̍ŏ̃f[^wB
				\param src1		̓f[^ւ̃|C^B̃|C^
								ŏ̏o̓f[^ꏊwB
				\param src2		̓f[^ւ̃|C^B̃|C^
								ŏ̏o̓f[^ꏊwB
				\param count	̓f[^B܂Ƃ߂ĉ̃f[^
								邩w肷BȂׂ傫
								l^قI[o[wbhłB
			*/
#pragma linkage_name _stkAddFunc
		extern void add( short dst[], short src1[], short src2[], unsigned int count );
			/*!
				\brief Z֐BxNgƃXJ[
				\param dst 		o̓f[^ւ̃|C^B̃|C^
								̓f[^̍ŏ̃f[^wB
				\param src1		̓f[^ւ̃|C^B̃|C^
								ŏ̏o̓f[^ꏊwB
				\param src2		̓f[^
				\param count	̓f[^B܂Ƃ߂ĉ̃f[^
								邩w肷BȂׂ傫
								l^قI[o[wbhłB
			*/
#pragma linkage_name _stkAddFunc2
		extern void add( short dst[], short src1[], short src2, unsigned int count );
			/*!
				\brief Z֐BxNgƃXJ[
				\param dst 		o̓f[^ւ̃|C^B̃|C^
								̓f[^̍ŏ̃f[^wB
				\param src1		̓f[^
				\param src2		̓f[^ւ̃|C^B̃|C^
								ŏ̏o̓f[^ꏊwB
				\param count	̓f[^B܂Ƃ߂ĉ̃f[^
								邩w肷BȂׂ傫
								l^قI[o[wbhłB
			*/

		inline void add( short dst[], short src1, short src2[], unsigned int count )
		{
			add( dst, src2, src1, count );
		}		
//--------------------------------------------------------------------------
			/*!
				\brief Z֐Bvfm̈Z
				\param dst 		o̓f[^ւ̃|C^B̃|C^
								̓f[^̍ŏ̃f[^wB
				\param src1		̓f[^ւ̃|C^B̃|C^
								ŏ̏o̓f[^ꏊwB
				\param src2		̓f[^ւ̃|C^B̃|C^
								ŏ̏o̓f[^ꏊwB
				\param count	̓f[^B܂Ƃ߂ĉ̃f[^
								邩w肷BȂׂ傫
								l^قI[o[wbhłB
			*/
#pragma linkage_name _stkSubtractFunc
		extern void sub( short dst[], short src1[], short src2[], unsigned int count );
			/*!
				\brief ϊ֐BxNgƃXJ[
				\param dst 		o̓f[^ւ̃|C^B̃|C^
								̓f[^̍ŏ̃f[^wB
				\param src1		̓f[^ւ̃|C^B̃|C^
								ŏ̏o̓f[^ꏊwB
				\param src2		̓f[^
				\param count	̓f[^B܂Ƃ߂ĉ̃f[^
								邩w肷BȂׂ傫
								l^قI[o[wbhłB
			*/
#pragma linkage_name _stkSubtractFunc2
		extern void sub( short dst[], short src1[], short src2, unsigned int count );
			/*!
				\brief ϊ֐BxNgƃXJ[
				\param dst 		o̓f[^ւ̃|C^B̃|C^
								̓f[^̍ŏ̃f[^wB
				\param src1		̓f[^
				\param src2		̓f[^ւ̃|C^B̃|C^
								ŏ̏o̓f[^ꏊwB
				\param count	̓f[^B܂Ƃ߂ĉ̃f[^
								邩w肷BȂׂ傫
								l^قI[o[wbhłB
			*/

#pragma linkage_name _stkSubtractFunc3
		extern void sub( short dst[], short src1, short src2[], unsigned int count );
//--------------------------------------------------------------------------
			/*!
				\brief Βl֐B
				\param dst 		o̓f[^ւ̃|C^B̃|C^
								̓f[^̍ŏ̃f[^wB
				\param src		̓f[^ւ̃|C^B̃|C^
								ŏ̏o̓f[^ꏊwB
				\param count	̓f[^B܂Ƃ߂ĉ̃f[^
								邩w肷BȂׂ傫
								l^قI[o[wbhłB
			*/
#pragma linkage_name _stkAabsoluteFunc
		extern void abs( short dst[], short src[], unsigned int count );

//--------------------------------------------------------------------------


};
#endif
